/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreMissingRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreMissing extends TableImpl<VCoreMissingRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_missing</code>
     */
    public static final VCoreMissing V_CORE_MISSING = new VCoreMissing();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreMissingRecord> getRecordType() {
        return VCoreMissingRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_missing.missinglist</code>.
     */
    public final TableField<VCoreMissingRecord, Integer> MISSINGLIST = createField(DSL.name("missinglist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missing.missingmastervalue</code>.
     */
    public final TableField<VCoreMissingRecord, Integer> MISSINGMASTERVALUE = createField(DSL.name("missingmastervalue"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missing.missingmaster_lang</code>.
     */
    public final TableField<VCoreMissingRecord, String> MISSINGMASTER_LANG = createField(DSL.name("missingmaster_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_missing.missingvalue_ecrf</code>.
     */
    public final TableField<VCoreMissingRecord, Boolean> MISSINGVALUE_ECRF = createField(DSL.name("missingvalue_ecrf"), SQLDataType.BOOLEAN, this, "");

    private VCoreMissing(Name alias, Table<VCoreMissingRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreMissing(Name alias, Table<VCoreMissingRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_missing" as  SELECT t_core_missingvalue.fk_missinglist AS missinglist,
         t_core_missingvalue.fk_missingmaster AS missingmastervalue,
         COALESCE(t_core_missingmaster.fk_lang, ('Error! no fk_lang for '::text || t_core_missingmaster.pk)) AS missingmaster_lang,
         t_core_missingvalue.missingvalue_ecrf
        FROM (common_dd.t_core_missingvalue
          LEFT JOIN common_dd.t_core_missingmaster ON ((t_core_missingmaster.pk = t_core_missingvalue.fk_missingmaster)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missing</code> table reference
     */
    public VCoreMissing(String alias) {
        this(DSL.name(alias), V_CORE_MISSING);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missing</code> table reference
     */
    public VCoreMissing(Name alias) {
        this(alias, V_CORE_MISSING);
    }

    /**
     * Create a <code>common_dd.v_core_missing</code> table reference
     */
    public VCoreMissing() {
        this(DSL.name("v_core_missing"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreMissing as(String alias) {
        return new VCoreMissing(DSL.name(alias), this);
    }

    @Override
    public VCoreMissing as(Name alias) {
        return new VCoreMissing(alias, this);
    }

    @Override
    public VCoreMissing as(Table<?> alias) {
        return new VCoreMissing(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissing rename(String name) {
        return new VCoreMissing(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissing rename(Name name) {
        return new VCoreMissing(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissing rename(Table<?> name) {
        return new VCoreMissing(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing where(Condition condition) {
        return new VCoreMissing(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissing where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissing where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissing where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissing where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissing whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
